﻿Type=Class
Version=3.2
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim Fields As List
	Dim FieldIDs As List
	Dim FieldsText As List
	Dim Repeat As Boolean = False
	Dim OrderVisible As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
'TheseFields should contain the list of EditTexts to be ordered, cRepeat is a bollean that determines if the order is looped
Public Sub Initialize(TheseFields As List,cRepeat As Boolean)

	Fields.Initialize
	FieldIDs.Initialize
	FieldsText.Initialize
	Repeat = cRepeat

	Fields.AddAll(TheseFields)

	Dim Refl As Reflector
	
	Dim IME As String = 5
	For i = 0 To Fields.Size-1
		'
		'Change the default actions here.... some actions may break the sequence
		'
		'Make sure Force Done is off set to IME_ACTION_NEXT = 5, IME_ACTION_DONE = 6
		Refl.Target= Fields.Get(i)
		'Except for last in the list if not repeating
		If i = Fields.Size-1 AND Repeat = False Then IME=6
		Refl.RunMethod2("setImeOptions",IME,"java.lang.int")
		FieldIDs.Add(Refl.RunMethod("getId"))
	Next
		
	For i = 0 To Fields.Size-1
		Refl.Target=Fields.Get(i)
		
		If i < Fields.Size-1 Then
			Dim n As String = FieldIDs.Get(i+1)
			Refl.RunMethod2("setNextFocusDownId",n,"java.lang.int")
			Refl.RunMethod2("setNextFocusRightId",n,"java.lang.int")
			
			'setNextFocusForwardID is available from API 11
			Try
				Refl.RunMethod2("setNextFocusForwardId",n,"java.lang.int")
			Catch
				'Failed but can't do anything about it
			End Try
			
		End If
		If i > 0 Then
			Dim n As String = FieldIDs.Get(i-1)
			Refl.RunMethod2("setNextFocusUpId",n,"java.lang.int")
			Refl.RunMethod2("setNextFocusLeftId",n,"java.lang.int")
		End If
		
		If Repeat Then
			'Sort out looping if needed
			If i = 0 Then
				Dim n As String = FieldIDs.Get(Fields.Size-1)
				Refl.RunMethod2("setNextFocusUpId",n,"java.lang.int")
				Refl.RunMethod2("setNextFocusLeftId",n,"java.lang.int")
			End If
			If i = Fields.Size-1 Then
				Dim n As String = FieldIDs.Get(0)
				Refl.RunMethod2("setNextFocusDownId",n,"java.lang.int")
				Refl.RunMethod2("setNextFocusRightId",n,"java.lang.int")
				
				'setNextFocusForwardID is available from API 11
				Try
					Refl.RunMethod2("setNextFocusForwardId",n,"java.lang.int")
				Catch
					'Failed but can't do anything about it
				End Try
			End If
		End If
	Next
End Sub
'For debugging show order in EditText fields
Sub ShowOrder
	Dim i As Int = 1
	FieldsText.Clear
	For Each F As EditText In Fields
		FieldsText.Add(F.Text)
		F.Text=i
		i=i+1
	Next
	OrderVisible=True
End Sub
'Restore Text as it was before ShowOrder was run
Sub HideOrder
	Dim i As Int =0
	For Each F As EditText In Fields
		F.Text=FieldsText.Get(i)
		i=i+1
	Next
	OrderVisible=False
End Sub